// THIS IS AN AUTOGENERATED FILE. DO NOT EDIT THIS FILE DIRECTLY.

import { z } from 'zod';

import {
  OidcClientMetadata,
  oidcClientMetadataGuard,
  CustomClientMetadata,
  customClientMetadataGuard,
  GeneratedSchema,
  Guard,
} from '../foundations';
import { ApplicationType } from './custom-types';

export type ApplicationUpdate = {
  id: string;
  name: string;
  description?: string | null;
  type: ApplicationType;
  oidcClientMetadata: OidcClientMetadata;
  customClientMetadata?: CustomClientMetadata;
  createdAt?: number;
};

export type Application = {
  id: string;
  name: string;
  description: string | null;
  type: ApplicationType;
  oidcClientMetadata: OidcClientMetadata;
  customClientMetadata: CustomClientMetadata;
  createdAt: number;
};

const guard: Guard<ApplicationUpdate> = z.object({
  id: z.string(),
  name: z.string(),
  description: z.string().optional(),
  type: z.nativeEnum(ApplicationType),
  oidcClientMetadata: oidcClientMetadataGuard,
  customClientMetadata: customClientMetadataGuard.optional(),
  createdAt: z.number().optional(),
});

export const Applications: GeneratedSchema<ApplicationUpdate> = Object.freeze({
  table: 'applications',
  tableSingular: 'application',
  fields: {
    id: 'id',
    name: 'name',
    description: 'description',
    type: 'type',
    oidcClientMetadata: 'oidc_client_metadata',
    customClientMetadata: 'custom_client_metadata',
    createdAt: 'created_at',
  },
  fieldKeys: [
    'id',
    'name',
    'description',
    'type',
    'oidcClientMetadata',
    'customClientMetadata',
    'createdAt',
  ],
  guard,
});
